export interface MonadModule {
    moduleName: string;
    moduleType: 'Model' | 'Function' | 'UI' | 'Server';
    dependencies?: MonadModule[];
}
export declare const monadModule: MonadModule;
export declare const monadApp: {
    runIO: import("fp-ts/lib/Reader").Reader<import("macoolka-object").DiffObject<import("macoolka-error/lib/io").IOProps<any>, {
        title: string;
    }>, any>;
    runIOWarn: <T>(r: import("macoolka-object").DiffObject<import("macoolka-error/lib/types").WarnMessage<import("macoolka-error/lib/io").IOProps<any>, T>, {
        title: string;
        warn: (a: string) => void;
    }>) => T;
    runTask: <T_1>(r: import("macoolka-object").DiffObject<import("macoolka-error/lib/task").TaskProps<T_1>, {
        title: string;
    }>) => Promise<T_1>;
    runTaskWarn: <T_2>(r: import("macoolka-object").DiffObject<import("macoolka-error/lib/types").WarnMessage<import("macoolka-error/lib/task").TaskProps<any>, T_2>, {
        title: string;
        warn: (a: string) => void;
    }>) => Promise<any>;
    invariant: <T_3>(r: import("macoolka-object").DiffObject<import("macoolka-error/lib/invariant").Props<T_3>, {
        title: string;
    }>) => void;
    invariantWarn: <T_4>(r: import("macoolka-object").DiffObject<import("macoolka-error/lib/types").WarnMessage<import("macoolka-error/lib/invariant").Props<T_4>, T_4>, {
        title: string;
        warn: (a: string) => void;
    }>) => T_4;
    propNotFound: import("fp-ts/lib/Reader").Reader<import("macoolka-object").DiffObject<import("macoolka-error/lib/propNotFound").PropNotFoundProps, {
        title: string;
    }>, any>;
    propNotFoundWarn: <T_5>(r: import("macoolka-object").DiffObject<import("macoolka-error/lib/types").WarnMessage<import("macoolka-error/lib/propNotFound").PropNotFoundProps, T_5>, {
        title: string;
        warn: (a: string) => void;
    }>) => any;
    wrapErrorToString: import("fp-ts/lib/Reader").Reader<import("macoolka-object").DiffObject<{
        title?: string | undefined;
        message: string;
        exception?: Error | undefined;
    }, {
        title: string;
    }>, string>;
};
export default monadApp;
